unit GUtils;

interface

  Uses Dos,Graph,GRMouse;

  procedure Initialize_Graph_Mode;
  procedure Create_Window( x1, y1, x2, y2 :Integer );
  procedure Destroy_Window( x1, y1, x2, y2 :Integer; BackColor:Word );
  procedure Create_Bar( x1, y1, x2, y2 :Integer );
  procedure Create_Bar_2( x1, y1, x2, y2 :Integer );
  procedure Destroy_Bar( x1, y1, x2, y2 :Integer; BackColor:Word );
  procedure GW( x, y :integer; Str1_ :Real ); {GW expansion is GraphWrite, on graph mode}
  procedure Draw_3D_Button( x1, y1, x2, y2 :Integer; BType :Byte);

implementation

procedure Initialize_Graph_Mode;
var
  GraphDriver, GraphMode : Integer;
begin
  DetectGraph(GraphDriver,GraphMode);
  InitGraph(GraphDriver,GraphMode,'');
  if GraphResult <> GrOk then
  begin
    Writeln(' Grafik Modu Yklenemedi HataKodu :',GrError);
    Halt;
  end;
end;

procedure Create_Window( x1, y1, x2, y2 :Integer );
var
  c : Byte;
begin
  c:=1;  { Optional Parameter }
  SetColor(0);
   Line(x1, y2, x2, y2);
   Line(x1+5*c, y1+5*c, x2-6*c, y1+5*c);
   Line(x1+5*c, y1+5*c, x1+5*c, y2-6*c);
   Line(x2, y1, x2, y2);
  Setcolor(8);
   Line(x1+1*c, y2-1*c, x2-1*c, y2-1*c);
   Line(x1+4*c, y1+4*c, x2-5*c, y1+4*c);
   Line(x1+4*c, y1+4*c, x1+4*c, y2-5*c);
   Line(x2-1*c, y1+1*c, x2-1*c, y2-1*c);
  SetColor(7);
   Line(x1+2*c, y2-2*c, x2-2*c, y2-2*c);
   Line(x1+2*c, y2-3*c, x2-2*c, y2-3*c);
   Line(x1+5*c, y2-5*c, x2-5*c, y2-5*c);
   Line(x1+2*c, y1+2*c, x2-2*c, y1+2*c);
   Line(x1+2*c, y1+3*c, x2-2*c, y1+3*c);
   Line(x1, y1, x2-1*c, y1);
   Line(x1+2*c, y1+2*c, x1+2*c, y2-2*c);
   Line(x1+3*c, y1+2*c, x1+3*c, y2-2*c);
   Line(x1, y1, x1, y2-1*c);
   Line(x2-2*c, y1+2*c, x2-2*c, y2-2*c);
   Line(x2-3*c, y1+2*c, x2-3*c, y2-2*c);
   Line(x2-5*c, y1+5*c, x2-5*c, y2-5*c);
  SetColor(15);
   Line(x1+4*c, y2-4*c, x2-4*c, y2-4*c);
   Line(x1+1*c, y1+1*c, x2-2*c, y1+1*c);
   Line(x1+1*c, y1+1*c, x1+1*c, y2-2*c);
   Line(x2-4*c, y1+4*c, x2-4*c, y2-4*c);
  SetFillStyle(1,7);
  Bar(x1+6*c, y1+6*c, x2-6*c, y2-6*c);
end;

procedure Destroy_Window( x1, y1, x2, y2 :Integer; BackColor:Word );
begin
  SetFillStyle(1,BackColor);
  Bar(x1, y1, x2, y2);
end;

procedure Create_Bar( x1, y1, x2, y2 :Integer );
begin
  SetFillStyle(1,7);
  Bar(x1, y1, x2, y2);
  SetColor(15);
  Line(x1, y1, x2, y1);
  Line(x1, y1, x1, y2);
  SetColor(8);
  Line(x2-1, y1+1, x2-1, y2-1);
  Line(x1+1, y2-1, x2-1, y2-1);
  SetColor(0);
  Line(x1, y2, x2, y2);
  Line(x2, y1, x2, y2);
  SetColor(0);
  Line(x1,y2,x2,y2);
  Line(x2,y1,x2,y2);
end;

procedure Create_Bar_2( x1, y1, x2, y2 :Integer );
begin
  SetFillStyle(1,7);
  Bar(x1, y1, x2, y2);
  SetColor(15);
  Line(x1, y1, x2, y1);
  Line(x1, y1, x1, y2);
  SetColor(8);
  Line(x1+1, y1+1, x1+1, y2-2);
  Line(x1+1, y1+1, x2-2, y1+1);
  Line(x2-1, y1+1, x2-1, y2-1);
  Line(x1+1, y2-1, x2-1, y2-1);
  SetColor(0);
  Line(x1, y2, x2, y2);
  Line(x2, y1, x2, y2);
  SetColor(0);
  Line(x1,y2,x2,y2);
  Line(x2,y1,x2,y2);
end;

procedure Destroy_Bar(x1, y1, x2, y2 :Integer; BackColor:Word);
begin
  SetFillStyle(1,BackColor);
  Bar(x1, y1, x2, y2);
end;

procedure GW(x, y:integer; Str1_:real);
{GW expansion is GraphWrite, on graph mode}
var
  Str1 : string;
begin
  SetFillStyle(1,1);
  SetColor(15);
  Str(Str1_:7:1, Str1);
  Bar(x, y, x+Length(Str1)*10, y+20);
  SetTextStyle(0,0,1);
  OutTextXY(x, y, str1);
end;

  procedure Draw_3D_Button( x1, y1, x2, y2 :Integer; BType :Byte);
  begin
  Hide_Mouse;
   case BType of
   0:begin
       SetFillStyle(1,7);
       Bar(x1,y1,x2,y2);
       SetColor(0);
       Rectangle(x1,y1,x2,y2);
       Rectangle(x1+1,y1+1,x2-1,y2-1);
       SetColor(15);
       Line(x1+1,y1+1,x2-2,y1+1);
       Line(x1+1,y1+1,x1+1,y2-2);
       SetColor(8);
       Line(x2-2,y1+2,x2-2,y2-2);
       Line(x1+2,y2-2,x2-2,y2-2);
     end;
   1:begin
       SetFillStyle(1,7);
       Bar(x1,y1,x2,y2);
       SetColor(0);
       Rectangle(x1,y1,x2,y2);
       SetColor(8);
       Rectangle(x1+1,y1+1,x2-1,y2-1);
     end;
   end;
  Show_Mouse;
  end;

end.